-- This file is for testing how cpld and virtex entities work
-- this file feeds EPP Parallel Port signals
	
library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;


	-- Add your library and packages declaration here ...

entity test is
end test;

architecture TB_ARCHITECTURE of test is
-- Component declaration of the tested unit
-- w przypadku kiedy element system nie jest znaleziony nalezy dokonac edycji tego pliku zmieniajac wyprowadzenia komponentu system (zgodnire z plikiem system.vhd) oraz dodajac ewentualne modele symulacyjne, np. sram_model

component system
  port (clk: in STD_LOGIC;
	-- external (PIN) signals connected to CPLD and Parallel Port (FPGA is a slave device to CPLD!)
	pp_wrn: in STD_LOGIC; -- signals are similar like for EPP (parallel port standard)
	pp_astbn: in STD_LOGIC; -- address strobe not
	pp_dstbn: in std_logic; -- data strobe not
	pp_wait: out std_logic; -- wait - similar like for EPP
	pp_d: inout STD_LOGIC_VECTOR (7 downto 0)); -- data bus 
  end component;
  
 component epp_model
	port(clk: in std_logic;
	-- signals are similar like for EPP (parallel port standard)	
	pp_wrn: out STD_LOGIC; -- write / not read
	pp_astbn: out STD_LOGIC; -- address strobe not
	pp_dstbn: out std_logic; -- data strobe not
	pp_wait: in std_logic; -- wait - similar like for EPP
	pp_d: inout std_logic_vector(7 downto 0)); -- data bus 
  end component;
   

  -- Parallel port Stimulus signals - signals mapped to the input and inout ports of tested entity
	signal clk : std_logic;
	signal pp_wrn : std_logic;
	signal pp_dstbn : std_logic;
	signal pp_astbn : std_logic;
	signal pp_wait : std_logic;
	signal pp_d : std_logic_vector(7 downto 0);
begin

	-- Unit Under Test port map			
  UUT: system
    port map (clk=> clk, --rstn=> rstn, 
	-- to CPLD
	pp_wrn=> pp_wrn, pp_astbn=> pp_astbn, pp_dstbn=> pp_dstbn, 
	pp_wait=>pp_wait, pp_d=> pp_d);
	
  process begin
	  wait for 10 ns;
	  clk<= '0';
	  wait for 10 ns;
	  clk<= '1';
  end process;

  pp: epp_model
	port map(clk => clk, pp_wrn=> pp_wrn, pp_astbn=> pp_astbn, pp_dstbn=> pp_dstbn, 
	pp_wait=> pp_wait, pp_d=>pp_d);
   	
end TB_ARCHITECTURE;

