-- XSB board only - test 
-- only external Parallel Port and clock are taken into account
	
library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;


	-- Add your library and packages declaration here ...

entity test is
end test;

architecture TB_ARCHITECTURE of test is

-- Component declaration of the tested unit
-- w przypadku kiedy element system nie jest znaleziony nalezy dokonac edycji tego pliku zmieniajac wyprowadzenia komponentu system (zgodnire z plikiem system.vhd) oraz dodajac ewentualne modele symulacyjne, np. sram_model
component system
  port (
    pp_dck : in std_logic;
    clk : in std_logic;
    pp_dwr : in std_logic;
    pp_drd : out std_logic
  );
  end component;
  
 component epp_model
	generic (T: time:= 41.6ns); -- CPLD clock perion = 24MHz
  port(pp_dck: out std_logic; -- data clock
	  pp_dwr: out STD_LOGIC; -- write data
    pp_drd: in std_logic); -- read data
  end component;
   

  -- Parallel port Stimulus signals - signals mapped to the input and inout ports of tested entity
	signal clk : std_logic;
	signal pp_dck, pp_dwr, pp_drd : std_logic;
begin

	-- Unit Under Test port map			
  UUT: system
    port map (clk=> clk, --rstn=> rstn, 
	-- to CPLD
    pp_dck=> pp_dck, pp_dwr=> pp_dwr, pp_drd=>pp_drd);
	
  process begin
	  wait for 10 ns;
	  clk<= '0';
	  wait for 10 ns;
	  clk<= '1';
  end process;

  pp: epp_model
	generic map(T=> 41.6ns)
    port map(pp_dck=> pp_dck, pp_dwr=> pp_dwr, pp_drd=> pp_drd);
   	
end TB_ARCHITECTURE;

